//GeoGet 2
// v2  Arne1  09.11.2017: U waypoint se nov generuj oba komente, oddlen dkem. Prn je GC.COM, druh Geoget.
//                        Poznmka u kee se generuje jako nov waypoint / Reference point, jmno "COMMENT", prefix "WW"


function ExportExtension: string;
begin
  result := 'GPX';
end;

function ExportDescription: string;
begin
  result := 'Exportni script pro GSAK v2';
end;

function ExportHint: string;
begin
  result := 'Basic exchange format for other apliacations. All in one file.';
  if copy(GetCurrentLanguage, 1, 2) = 'cs' then
    result := 'Zkladn vmnn formt pro ciz apliakce. Ve do jednoho souboru.';
end;

function ExportHeader: string;
begin
  Result := '<?xml version="1.0" encoding="utf-8"?>' + CRLF;
  Result := Result + '<gpx xmlns:xsd="http://www.w3.org/2001/XMLSchema"'
    + ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0"'
    + ' creator="Groundspeak Pocket Query"'
    + ' xsi:schemaLocation="http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd'
    + ' http://www.groundspeak.com/cache/1/0/1 http://www.groundspeak.com/cache/1/0/1/cache.xsd"'
    + ' xmlns="http://www.topografix.com/GPX/1/0">' + CRLF;
  Result := Result + ' <desc>Geocache file (HasChildren)</desc>' + CRLF;
  Result := Result + ' <author>' + Geoget_Version + '</author>' + CRLF;
  Result := Result + ' <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', now) + '</time>' + CRLF;
  Result := Result + ' <keywords>cache, geocache, groundspeak</keywords>' + CRLF + CRLF;
end;

function ExportFooter: string;
begin
  result := '</gpx>' + CRLF;
end;

function ExportAttributes: string;
var
  l: TStringList;
  n: integer;
  aicon: string;
  aid: string;
  apq: string;
  ainc: string;
begin
  Result := '   <groundspeak:attributes>' + CRLF;
  l := TstringList.Create;
  try
    l.text := GC.TagValues('attribute');
    for n := 0 to l.count - 1 do
    begin
      aicon := trim(l[n]);
      aid := IconToAttributeID(aicon);
      if aid = '' then
        continue;
      apq := IconToAttributePQ(aicon);
      if apq <> '' then
        if apq[1] = '-' then
          delete(apq, 1, 1);
      ainc := '1';
      if aid <> '' then
        if aid[1] = '-' then
        begin
          delete(aid, 1, 1);
          ainc := '0';
        end;
      Result := Result + '     <groundspeak:attribute id="' + aid + '" inc="' + ainc + '">'
        + apq + '</groundspeak:attribute>' + CRLF;
    end;
  finally
    l.free;
  end;
  Result := Result + '   </groundspeak:attributes>' + CRLF;
end;

function ExportPoint: string;
var
  s: string;
  n: integer;
begin
  Result := '';
  //Export for Geocaches
  if GC.IsListed then
  begin
    Result := Result + ' <wpt lat="' + GC.Lat + '" lon="' + GC.Lon + '">' + CRLF;
    Result := Result + '  <time>'
      + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
    Result := Result + '  <name>' + GC.ID +'</name>' + CRLF;
    Result := Result + '  <desc>' + cdata(GC.Name + ' by ' + GC.Author
          + ' (' + GC.Difficulty + '/' + GC.Terrain + ')') +'</desc>' + CRLF;
    Result := Result + '  <url>' + cdata(GC.URL) +'</url>' + CRLF;
    Result := Result + '  <urlname>' + cdata(GC.Name) + '</urlname>' + CRLF;
//    if GC.IsFound then
//      Result := Result + '  <sym>Geocache Found</sym>' + CRLF
//    else
      Result := Result + '  <sym>Geocache</sym>' + CRLF;
    Result := Result + '  <type>Geocache|' + GC.CacheType + '</type>' + CRLF;
    if GC.IsDisabled then
      s := 'available="False"'
    else
      s := 'available="True"';
    if GC.IsArchived then
      s := s + ' archived="True"'
    else
      s := s + ' archived="False"';
    s := 'id="' + GC.CacheID +'" ' + s;
    Result := Result + '  <groundspeak:cache ' + s + ' xmlns:groundspeak="http://www.groundspeak.com/cache/1/0/1">' + CRLF;
    Result := Result + '   <groundspeak:name>' + cdata(GC.Name) + '</groundspeak:name>' + CRLF;
    Result := Result + '   <groundspeak:placed_by>' + cdata(GC.Author) +'</groundspeak:placed_by>' + CRLF;
    if GC.OwnerID <> '' then
      Result := Result + '   <groundspeak:owner id="' + GC.OwnerID + '">' + cdata(GC.Author) +'</groundspeak:owner>' + CRLF;
    Result := Result + '   <groundspeak:type>' + GC.CacheType +'</groundspeak:type>' + CRLF;
    Result := Result + '   <groundspeak:container>' + GC.Size +'</groundspeak:container>' + CRLF;
    Result := Result + ExportAttributes;
    Result := Result + '   <groundspeak:difficulty>' + GC.Difficulty +'</groundspeak:difficulty>' + CRLF;
    Result := Result + '   <groundspeak:terrain>' + GC.Terrain +'</groundspeak:terrain>' + CRLF;
    Result := Result + '   <groundspeak:country>' + GC.Country +'</groundspeak:country>' + CRLF;
    Result := Result + '   <groundspeak:state>' + GC.State +'</groundspeak:state>' + CRLF;
    Result := Result + '   <groundspeak:short_description html="True">' + cdata(GC.ShortDescription) +'</groundspeak:short_description>' + CRLF;
    Result := Result + '   <groundspeak:long_description html="True">' + cdata(GC.LongDescription) +'</groundspeak:long_description>' + CRLF;
    Result := Result + '   <groundspeak:encoded_hints>' + cdata(GC.Hint) +'</groundspeak:encoded_hints>' + CRLF;
    Result := Result + '   <groundspeak:logs>' + CRLF;
    for n := 0 to GC.Logs.Count - 1 do
    begin
      Result := Result + '    <groundspeak:log id="' + GC.Logs[n].LogID + '">' + CRLF;
      Result := Result + '     <groundspeak:date>' 
        + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Logs[n].Date) + '</groundspeak:date>' + CRLF;
      Result := Result + '     <groundspeak:type>' + GC.Logs[n].LogType + '</groundspeak:type>' + CRLF;
      s := '';
      if GC.Logs[n].FinderID <> '' then
        s := ' id="' + GC.Logs[n].FinderID + '"'; 
      Result := Result + '     <groundspeak:finder' + s + '>' + cdata(GC.Logs[n].Finder) + '</groundspeak:finder>' + CRLF;
      Result := Result + '     <groundspeak:text encoded="False">' + cdata(GC.Logs[n].Text) + '</groundspeak:text>' + CRLF;
      Result := Result + '    </groundspeak:log>' + CRLF;
    end;
    Result := Result + '   </groundspeak:logs>' + CRLF;
    Result := Result + '  </groundspeak:cache>' + CRLF;
    Result := Result + ' </wpt>' + CRLF + CRLF;
  end;
  //Export for Waypoints
  for n := 0 to GC.Waypoints.Count - 1 do
    if GC.Waypoints[n].IsListed then
    begin
      Result := Result + ' <wpt lat="' + GC.Waypoints[n].Lat + '" lon="' + GC.Waypoints[n].Lon + '">' + CRLF;
      Result := Result + '  <time>'
        + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
      Result := Result + '  <name>' + GC.Waypoints[n].ID +'</name>' + CRLF;
      Result := Result + '  <cmt>'
      if GC.Waypoints[n].Description<>'' then   Result := Result + cdata(GC.Waypoints[n].Description + CRLF + GC.Waypoints[n].Comment)
                                         else   Result := Result + cdata(GC.Waypoints[n].Comment);
      Result := Result + '</cmt>' + CRLF + CRLF;
      Result := Result + '  <desc>' + cdata(GC.Waypoints[n].Name) +'</desc>' + CRLF;
      Result := Result + '  <url>' + cdata(GC.Waypoints[n].URL) +'</url>' + CRLF;
      Result := Result + '  <urlname>' + cdata(GC.Waypoints[n].Name) + '</urlname>' + CRLF;
      Result := Result + '  <sym>' + GC.Waypoints[n].WptType + '</sym>' + CRLF
      Result := Result + '  <type>Waypoint|' + GC.Waypoints[n].WptType + '</type>' + CRLF;
      Result := Result + ' </wpt>' + CRLF + CRLF;
    end;
  if GC.comment <> '' then
  begin
    Result := Result + ' <wpt lat="' + GC.Lat + '" lon="' + GC.Lon + '">' + CRLF;
    Result := Result + '  <time>'
      + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
    Result := Result + '  <name>WW' + copy(GC.ID,3,6) +'</name>' + CRLF;
    Result := Result + '  <cmt>' + cdata(GC.Comment) +'</cmt>' + CRLF;
    Result := Result + '  <desc>' + '<![CDATA[COMMENT]]>' +'</desc>' + CRLF;
    Result := Result + '  <sym>' + 'Reference Point' + '</sym>' + CRLF
    Result := Result + '  <type>Waypoint|' + 'Reference Point' + '</type>' + CRLF;
    Result := Result + ' </wpt>' + CRLF + CRLF;
  end;
end;
